create table t_parts (partNumber int, partdesc varchar(6))
go

create table t_orderLineItem ([order] int, partNumber int)
go

insert into t_orderLineItem values (100, 333)
insert into t_orderLineItem values (200, 444)
insert into t_orderLineItem values (200, 333)
go

insert into t_parts values (99,'gear')
insert into t_parts values (333,'wheel')
insert into t_parts values (444,'bolt')
go

drop function udf_partsOnOrders
create function udf_partsOnOrders( @partNumber int )
returns table 
return (select [order] from t_orderLineItem
 where @partNumber = partNumber )
go


-- use case: parts needed to fulfill orders 
select * from t_parts cross APPLY 
	dbo.udf_partsOnOrders(partNumber)
go

-- use case: kit list, how many of each part to fulfill orders
select partNumber, count(partNumber) from t_parts cross APPLY 
	dbo.udf_partsOnOrders(partNumber) group by partNumber
go

-- use case: none, shows outer apply
select * from t_parts OUTER APPLY 
	dbo.udf_partsOnOrders(partNumber) where [order]
go

-- use case: show parts that can be returned to stock
select * from t_parts OUTER APPLY 
	dbo.udf_partsOnOrders(partNumber) where [order] is null
go





