USE AdventureWorks
GO

SELECT VendorID, [164] AS Emp1, [198] AS Emp2, [223] AS Emp3, [231] AS Emp4, [233] AS Emp5
FROM 
(SELECT PurchaseOrderID, EmployeeID, VendorID
FROM Purchasing.PurchaseOrderHeader) p
PIVOT
(
COUNT (PurchaseOrderID)
FOR EmployeeID IN
( [164], [198], [223], [231], [233] )
) AS pvt
ORDER BY VendorID
GO


CREATE TABLE pvt (VendorID int, Emp1 int, Emp2 int,
Emp3 int, Emp4 int, Emp5 int)
GO
INSERT INTO pvt VALUES (111,4,3,5,4,4)
INSERT INTO pvt VALUES (222,4,1,5,5,5)
INSERT INTO pvt VALUES (333,4,3,5,4,4)
INSERT INTO pvt VALUES (444,4,2,5,5,4)
INSERT INTO pvt VALUES (555,5,1,5,5,5)
GO

SELECT * FROM pvt

--Unpivot the table.

-- generate dup rows, 
-- one for each row in IN clause * number of input rows
-- generate result values
-- filter out rows with NULLs

SELECT VendorID, Employee, Orders
FROM 
   (SELECT VendorID, Emp1, Emp2, Emp3, Emp4, Emp5
   FROM pvt) p
UNPIVOT
   (Orders FOR Employee IN 
      (Emp1, Emp2, Emp3, Emp4, Emp5)
)AS unpvt
GO